/**
 * @author John Foley <jpf7324@truman.edu>
 * @author Curtis Kelsey <kelseyc@truman.edu>
 *
 * Controller for the lab feed.
 */
angular.module(
    "TrumanApp.lab",
    [
        'ionic'
    ]
).controller(
    'LabCtrl',
    [
        '$scope',
        '$http',
        '$log',
        'CONFIG',
        function ($scope, $http, $log, CONFIG) {

            $scope.toggleLoading = false;

            /**
             * Initialize network error message to not show.
             * @type {boolean}
             */
            $scope.networkError = false;

            /**
             * @author John Foley
             * @param _url
             *
             * Opens the specified url using the system browser
             * requires this plugin: cordova plugin add org.apache.cordova.inappbrowser
             */
            $scope.open = function (_url) {
                window.open(_url, '_blank', 'location=yes');
            };

            $http.get(
                CONFIG.LAB_AVAIL_API_URL,
                {
                    withCredentials: false
                }
            ).success(function (data, status, headers, config) {

                    $scope.toggleLoading = true;
                    $scope.networkError = false;

                    $scope.labFeed = data._embedded.lab_availability[0].item;
                }
            ).error(function (data, status, headers, config) {

                    // called asynchronously if an error occurs
                    // or server returns response with an error status.

                    $scope.toggleLoading = true;
                    $scope.networkError = true;
                }
            );
        }
    ]
);