/**
 * @author John Foley <jpf7324@truman.edu>
 * @date 1/22/15
 *
 * Controller for the news feed
 */

angular.module(
    "TrumanApp.news",
    [
        'ionic',
        'TrumanApp.services'
    ]
).controller(
    'NewsCtrl',
    [
        '$scope',
        '$http',
        '$log',
        'CONFIG',
        function ($scope, $http, $log, CONFIG) {

            /**
             * @author John Foley
             * @param _url
             *
             * Opens the specified url using the system browser
             * requres this plugin: cordova plugin add org.apache.cordova.inappbrowser
             */
            $scope.open = function (_url) {
                window.open(_url, '_blank', 'location=yes');
            };

            $scope.failureNetwork = false;
            $scope.toggleLoading = false;

            $http.get(
                CONFIG.TRUMAN_TODAY_API_URL,
                {
                    withCredentials: false,
                    cache: CONFIG.CACHE_ENABLED
                }
            ).success(
                function (data, status, headers, config) {

                    $scope.toggleLoading = true;

                    $scope.newsFeed = data._embedded.truman_today[0].item;
                }
            ).error(
                function (data, status, headers, config) {

                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    $scope.failureNetwork = true;
                    $scope.toggleLoading = true;
                }
            );
        }
    ]
);