/**
 * @author John Foley <jpf7324@truman.edu>
 * @author Curtis Kelsey <kelseyc@truman.edu>
 *
 * Controller for Truman Media Network tab
 */
angular.module(
    "TrumanApp.tmn",
    [
    'ionic'
]
).controller(
    'TmnCtrl',
    [
        '$scope',
        '$http',
        '$log',
        'CONFIG',
        function ($scope, $http, $log) {

            /**
             * Initialize network error to not show
             * @type {boolean}
             */
            $scope.networkError = false;

            /**
             * @author John Foley
             * @param _url
             *
             * Opens the specified url using the system browser
             * requres this plugin: cordova plugin add org.apache.cordova.inappbrowser
             */
            $scope.open = function (_url) {
                window.open(_url, '_blank', 'location=yes');
            };

            /**
             * Initialize loading screen to now show
             * @type {boolean}
             */
            $scope.toggleLoading = false;

            var _url = "http://api.truman.edu/truman-media-network",
                config = {withCredentials: false}
                ;

            $http.get(_url, config)
                .success(function (data, status, headers, config) {

                    $scope.toggleLoading = true;
                    $scope.networkError = false;

                    $scope.tmnFeed = data._embedded.truman_media_network;
                    $log.debug($scope.tmnFeed);

                    for (var i = 0; i < $scope.tmnFeed.length; i++) {

                        var temp = $scope.tmnFeed[i].thumbnail;
                        $log.debug(temp);
                        if (temp) {
                            temp = temp.split(',');
                            $log.debug(temp);
                        }

                        if (typeof temp === 'undefined') {
                            continue;
                        }

                        if (temp.constructor === Array) {
                            temp = temp[0].split(' ');
                            $log.debug(temp);
                        }

                        if (temp.constructor === Array) {
                            $scope.tmnFeed[i].thumbnail = temp[0];
                        }
                    }
                })
                .error(function (data, status, headers, config) {

                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    $scope.networkError = true;
                    $scope.toggleLoading = true;
                })
            ;
        }])
;