/**
 * @author John Foley <jpf7324@truman.edu>
 * @date 1/22/15
 *
 * controller for Youtube. Gets the youtube feed and then lists the videos. videos
 *  are clickable and will play in a native player to the device
 *
 *  @deps $scope, $http, $ionicSideMenuDelegate
 */

angular.module("TrumanApp.youtube", [
    'ionic'
])

    .controller('YoutubeCtrl', ['$scope', '$http',
        function ($scope, $http) {

            /**
             * initialize loading screen to not hide
             * @type {boolean}
             */
            $scope.toggleLoading = false;

            $scope.networkError = false;

            var _apiKey = 'AIzaSyCbstE__HeWazle17lK2tn9OAkf3QkNuys';
            var _order = 'date';
            var _part = 'id%2Csnippet';
            var _channelId = 'UCWqd0HUsFSybKgSKNEi2V6w';
            var _pageToken = '';
            var _config = {withCredentials: false};

            $scope.getYouTubeUrl = function() {

                var url = "https://www.googleapis.com/youtube/v3/search?order="+_order+"&part="+_part+"&channelId="+_channelId+"&key="+_apiKey;

                if (_pageToken != '') {
                    url = url += "&pageToken="+_pageToken;
                }

                return url;
            }

            /**
             * function to play youtube video on click using the native video player
             */
            $scope.playme = function(item) {

                var version = ionic.Platform.version();

                if (ionic.Platform.isAndroid() && version >= 5 || version === 0) {
                    window.open("https://www.youtube.com/watch?v="+item, '_blank', 'location=yes');
                } else {
                    YoutubeVideoPlayer.openVideo(item);
                }
            };

            $scope.moreDataCanBeLoaded = function() {

                return _pageToken;
            }

            $scope.loadMore = function() {

                $http.get($scope.getYouTubeUrl(), _config)

                    .success(function (data, status, headers, config) {
                        if (data.nextPageToken) {
                            _pageToken = data.nextPageToken;
                        } else {
                            _pageToken = '';
                        }

                        //Append the records to the bottom of the list
                        Array.prototype.push.apply($scope.youtubeFeed, data.items);
                    })
                    .error(function (data, status, headers, config) {

                        // called asynchronously if an error occurs
                        // or server returns response with an error status.
                        $scope.networkError = true;

                    })
                    .finally(function(){
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    })

                ;
            }

            $http.get($scope.getYouTubeUrl(), _config)

                .success(function (data, status, headers, config) {

                    // hide the loading screen
                    $scope.toggleLoading = true;

                    // Hand off to the view
                    $scope.youtubeFeed = data.items;

                    if (data.nextPageToken) {
                        _pageToken = data.nextPageToken;
                    }
                })
                .error(function (data, status, headers, config) {

                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    $scope.networkError = true;

                })

            ;
        }])
;