/*jslint latedef:false*/
/**
 * @author John Foley <jpf7324@truman.edu>
 * @date 3/11/15
 */

'use strict';

describe('Calendar =>', function() {
    // Load the module with MainController
    beforeEach(module('TrumanApp.calendar'));

    var $controller, $scope;
    // inject the $controller and $rootScope services
    // in the beforeEach block
    // NOTE: The test runner will unwrap these variables for us during parsing.
    beforeEach(inject(function (_$controller_, $rootScope) {
        $scope = $rootScope.$new();
        // Create the controller
        $controller = _$controller_;
    }));

    describe("Moment Filter =>", function() {
        it("Should correctly format without UTC flag",
            inject(function(momentFilter) {

                var DTSTART = "20150312T223000";

                expect(momentFilter(DTSTART, 'h:mma')).toBe('5:30pm');
        }));

        it("Should correctly format with UTC flag",
            inject(function(momentFilter) {

                var DTSTART = "20150314T010000Z";

                expect(momentFilter(DTSTART, 'h:mma')).toBe('8:00pm');
        }));
    });

    describe('CalendarCtrl =>', function() {
        //noinspection JSUnusedLocalSymbols
        var controller;

        beforeEach(function() {
            //noinspection JSUnusedLocalSymbols
            controller = $controller('CalendarCtrl',
                {
                    $scope: $scope
                }
            );
        });

        it("Should exist", function() {
            expect(controller).toBeDefined();
        });


    })
});